// -*- coding:euc-jp -*-
#pragma once

#define CANNA_NEW_WCHAR_AWARE
#ifdef __WINNT__
  #include <windows.h>
  #ifdef HAVE_IMMDEV
    #include <immdev.h>
  #else
    #include <ddk/imm.h>
  #endif
  #if defined(__FreeBSD__)
    #define _WCHAR_T_DECLARED
  #endif
#else
  typedef void* HWND;
  typedef void* HIMC;
  typedef void* COMPOSITIONSTRING;
  typedef void CANDIDATELIST;
  typedef int BOOL;
  typedef unsigned int DWORD;
  typedef const void* LPCVOID;
  #define WINAPI
#endif
#include <stdint.h>
#include <canna/RK.h>
#include "lib/array.h"

/* version.hذư
#define WIME_CANNA_MAJOR 3
#define WIME_CANNA_MINOR 6
*/
#define RETURN_VERSION_ERROR_STAT -2

#include "so/pkt.h"
#define CANNAHEADERSIZE sizeof(CanHeader)

typedef struct{
    HWND Win;
    int Conv;		//Ѵʸֹ롣ʳξ֤λ-1
    int FerMode;	//RkBgnBunΥ⡼
    RkStat RkSt;	//!!! äƤɬפʤ
    Array CandInfo;	//ʸѴꥹȤΥڡ
    int Connection;	//̿Υեǥץ
    unsigned SerialNum; //ֹ̤档 memo'libcannaȤʻ'򻲾 !!!ä
    unsigned Flags;
    unsigned XWin;	//KeyPress٥ȤXΥɥ
    HIMC DefImc;	//ǥեimc
    HWND ImeWnd;	//imcĤäƤime-window
    bool UseToolbar;	//ġСȤȤtrue
    bool ImeOpen;	//ץ󤷤ƤtrueƥȤȤ˸̤˾֤ġ
    
    Array Dics;		//̾Υꥹ(char*)
    Array DicMode;	//Υ⡼(int32)

    int FixedNum;	//ưѴ⡼ɤǾ˳ꤵ줿ʸο
    Array FixedStr;	//˳ꤵ줿ʸηʸΥꥹ(u16)
    Array FixedYomi;	//ʸɤ߲̾Υꥹ(u16)
    int YomiBufStart;	//canna"ɤߥХåե"γϰ(compreadƬΥեå)
    int ConvertedCl;	//ưѴƤʸο
} CannaContext_t;

//CannaContext_t.Flags  wimectrl'-x c'ǥե饰̾ȤäƤ롣
#define OPEN_STATUS_WINDOW	(1<<0)	//ơɥɽƤ
#define PROC_NOTIFY_MSG		(1<<1)	//WM_IME_NOTIFYDefWindowProcˤ錄(ơɥȤ)
#define PROC_COMP_MSG		(1<<2)	//WM_IME_COMPOSITIONDefWindowProcˤ錄(ѴɥȤ)
#define PENDING_RECONV		(1<<3)	//ѴΥå褿
#define SEND_KEY		(1<<4)	//wm_wime_send_keyȤä
#define TRAP_OPEN_CAND		(1<<5)	//䥦ɥ褦Ȥ(WM_IME_NOTIFY,IMN_OPENCANDIDATE)
#define CATCH_OPEN_CAND		(1<<6)	//TRAP_OPEN_CAND˰ää餳Υե饰򥻥åȤ
#define CATCH_CHG_CAND		(1<<7)	//TRAP_OPEN_CAND˰ää餳Υե饰򥻥åȤ
#define USE_UTF16LE		(1<<8)
#define USE_UTF16BE		(1<<9)
#define USE_UTF16		(USE_UTF16LE|USE_UTF16BE)
#define CATCH_FINISH		(1<<10) //WM_IME_COMPOSITIONѴꤷȤ

//CandInfo
#define CANDLISTMAX 4
typedef struct{
    int Size[CANDLISTMAX];	//ƥڡθ
    int Seq;			//䥦ɥФʤȤθ
} CandListPageInfo;

//饤Ⱦ
typedef struct{
    int Connection; //̿Υեǥץ
    char* User;
    char* App;
    char* Group;
} ClientData_t;
    
//ʻ쥳
typedef struct{
    char* Ccode;	//ʤΥɡƬ'#'ϤĤʤɽ
    int Wcode;		//STYLEBUF.dwStyle
} HinshiCor;

//եΥǡ,¾
struct GlobalData_t{
    HinshiCor* HinshiTab;	//ʻ쥳

    //lookup_cand_win()ǻ ImmGetCandidateListȤäƸʸ
    void (*GetCandidate)(HIMC imc,const CannaContext_t* cx,Array* euclist,int clnum,unsigned listnum,CANDIDATELIST* cb);

    //unicode=1,sjis=2
    int CharStep;

    //ImmSet/GetCompositionString
    //!!!ǤɬפΤĴľ
    BOOL WINAPI (*SetCompStr)(HIMC,DWORD,LPCVOID,DWORD,LPCVOID,DWORD);
    uint16_t* (*GetCompStr)(HIMC imc,DWORD index);

    int CandIndexStart; //IME_PROP_CANDLIST_START_FROM_1 ???ȻȤƤ?

    int (*ImeVersion)(void); //imeΥС֤
};
extern struct GlobalData_t WimeData;

//WimeData.GetCandidate
void GetCandidateAtok(HIMC imc,const CannaContext_t* cx,Array* euclist,int clnum,unsigned listnum,CANDIDATELIST* cb);
void GetCandidateW(HIMC imc,const CannaContext_t* cx,Array* euclist,int clnum,unsigned listnum,CANDIDATELIST* cb);


typedef bool (*WMCANNAPROTO)(CanHeader*,int);

bool Init(CanHeader* ch,int fd);
bool Finalize(CanHeader* ch,int fd);
bool CreateContext(CanHeader* ch,int fd);
bool DupContext(CanHeader* ch,int fd);
bool CloseContext(CanHeader* ch,int fd);
bool GetDicList(CanHeader* ch,int fd);
bool GetDirList(CanHeader* ch,int fd);
bool MountDic(CanHeader* ch,int fd);
bool UnmountDic(CanHeader* ch,int fd);
bool BeginConv(CanHeader* ch,int fd);
bool GetCandiList(CanHeader* ch,int fd);
bool SetAppName(CanHeader* ch,int fd);
bool NoticeGroup(CanHeader* ch,int fd);
bool GetStatus(CanHeader* ch,int fd);
bool EndConv(CanHeader* ch,int fd);
bool ResizePause(CanHeader* ch,int fd);
bool DefineWord(CanHeader* ch,int fd);
bool RemountDic(CanHeader* ch,int fd);
bool MountDicList(CanHeader* ch,int fd);
bool QueryDic(CanHeader* ch,int fd);
bool DeleteWord(CanHeader* ch,int fd);
bool GetYomi(CanHeader* ch,int fd);
bool SubstYomi(CanHeader* ch,int fd);
bool StoreYomi(CanHeader* ch,int fd);
bool StoreRange(CanHeader* ch,int fd);
bool GetLastYomi(CanHeader* ch,int fd);
bool FlushYomi(CanHeader* ch,int fd);
bool RemoveYomi(CanHeader* ch,int fd);
bool GetSimpleKanji(CanHeader* ch,int fd);
bool GetHinshi(CanHeader* ch,int fd);
bool GetLex(CanHeader* ch,int fd);
bool SetLocale(CanHeader* ch,int fd);
bool AutoConv(CanHeader* ch,int fd);
bool QueryExt(CanHeader* ch,int fd);
bool KillServer(CanHeader* ch,int fd);

bool GetServerInfo(CanHeader* ch,int fd);
bool GetAcl(CanHeader* ch,int fd);
bool CreateDic(CanHeader* ch,int fd);
bool DeleteDic(CanHeader* ch,int fd);
bool RenameDic(CanHeader* ch,int fd);
bool GetWordTextDic(CanHeader* ch,int fd);
bool ListDic(CanHeader* ch,int fd);
bool Sync(CanHeader* ch,int fd);
bool ChmodDic(CanHeader* ch,int fd);
bool CopyDic(CanHeader* ch,int fd);

bool OpenDialog(CanHeader* ch,int fd);
bool SetCompWin(CanHeader* ch,int fd);
bool GetCompWin(CanHeader* ch,int fd);
bool SendKey(CanHeader* ch,int fd);
bool EnableIme(CanHeader* ch,int fd);
bool MoveShadowWin(CanHeader* ch,int fd);
bool SetCompFont(CanHeader* ch,int fd);
bool GetCompStr(CanHeader* ch,int fd);
bool SetCandWin(CanHeader* ch,int fd);
bool RegXWin(CanHeader* ch,int fd);
bool GetResultStr(CanHeader* ch,int fd);
bool SetResultStr(CanHeader* ch,int fd);
bool Reconvert(CanHeader* ch,int fd);
bool SetImeFocus(CanHeader* ch,int fd);
bool ShowToolbar(CanHeader* ch,int fd);
bool GetStyleList(CanHeader* ch,int fd);
bool ReloadConf(CanHeader* ch,int fd);
bool FlushMsg(CanHeader* ch,int fd);
bool ShowCandWin(CanHeader* ch,int fd);
bool SelectCand(CanHeader* ch,int fd);
bool CloseCandWin(CanHeader* ch,int fd);
bool DumpContext(CanHeader* ch,int fd);
bool SetDebugChannel(CanHeader* ch,int fd);
bool GetColor(CanHeader* ch,int fd);
bool GetCandWin(CanHeader* ch,int fd);
bool CandIndex(CanHeader* ch,int fd);

//(C) 2008 thomas
