#pragma once

#include <stdarg.h>
#include <string.h>

#ifdef __cplusplus
extern "C"{
#endif

typedef void (*ArNewCtr)(void* elem);
typedef struct{
    void* adr;
    int blocksize;
    int use;
    int reserve;
    int pagesize;
    ArNewCtr constructor;
} Array;

Array* ArNew(Array* ws,int bs,ArNewCtr ct);
/* wsNULLΤȤmalloc()ǳݤ롣顼λNULL֤ */

Array* ArNewPs(Array* ws,int bs,ArNewCtr ct,int pagesize);
/* pagesizeꤷȤ */

Array* ArDelete(Array* ws);
/* wsȤäƤ롣wsϺƽ롣 */

Array* ArClear(Array* ws);
/* Ǥο򣰤ˤ롣ϲʤ */

Array* ArReserve(Array* ws,int count);
/* **countĤΰݤ롣ݤǡuseѹʤ
   ɲóݤconstructorƤФ롣顼λNULL֤ */

void* ArAlloc(Array* a,int count);
/* countĳݤ롣usecountˤʤ롣
   Хåեɥ쥹֤顼λNULL֤*/

void* ArExpand(Array* ws,int count);
/* countɲûѤ롣 *ʬƬ*֤顼λNULL֤*/

Array* ArAddN(Array* ws,const void* valptr,size_t count);
/* valptrcountɲáws֤ 顼λNULL֤*/

static inline Array* ArAdd1(Array* a,const void* p){return ArAddN(a,p,1);}
/* p1ɲ( *(type*)pɲä) */

static inline Array* ArAddChar(Array* ws,char c){ return ArAdd1(ws,&c);}
/* ws1ʸɲáwschar wsǥ1ХȤˤ뤳ȡ*/

static inline Array* ArAddStr(Array* ws,const char* str){ return ArAddN(ws,str,strlen(str)+1);}
/* wsʸɲḁ́ʸѿ˴ޤࡣwsǥ1ХȤˤ뤳ȡ*/
    
Array* ArAddAr(Array* a,const Array* b);
/* a += b */

Array* ArRemove(Array* ws,int pos,int count);
/* posܤcountĤǤ롣꤬¿Ȥposʹߤ̤ѤȤ롣*/

static inline void* ArElemNc(const Array* ws,int pos){
    return (ws && ws->adr) ? (char*)(ws->adr)+pos*ws->blocksize : NULL; }
/* pos(>=0)ܤǤΥɥ쥹֤åʤ*/

static inline void* ArElem(const Array* ws,int pos){
    return (ws && pos>=0 && pos<ws->use) ? ArElemNc(ws,pos) : NULL; }
/* pos(>=0)ܤǤΥɥ쥹֤å*/
    
Array* ArInsert(Array* ws,int pos,int count,const void* valptr);
/* ws[pos]ΰ֤valptrcountĤ롣 */

int ArIndex(Array* ws,const void* ptr);
/* ptrֹ֤ptrϤwsΥɥ쥹Ǥ뤳ȡ
   顼(a==NULL)λ-1֤*/

int ArFind(const Array* ws,int pos,const void* val);
/* Ƥ*valǤΥǥå֤ pos=ϥǥå
   Ĥʤor顼λ-1֤*/

typedef int (*ArFindFunc)(const void* elem,const void* val);
int ArFindIf(const Array* ws,int start,ArFindFunc eq,const void* val);
/* eq(ǥɥ쥹,val)ˤʤǤֹ֤ ĤʤȤ-1֤ */

void* ArFindElemIf(Array* ws,int start,ArFindFunc eq,const void* val);
/*eq(val,ǥɥ쥹)ˤʤǤΥɥ쥹֤ĤʤȤArExpandƤӽФ*/

Array* ArCopy(Array* dst,const Array* src);
/* dst=src  dst֤顼λNULL֤dst˲Ƥ*/

static inline void* ArAdr(Array* a){return a!=NULL ? a->adr : NULL;}
//Хåեɥ쥹֤

static inline const void* ArAdrC(const Array* a){return a!=NULL ? a->adr : NULL;}
//const

static inline int ArBlockSize(const Array* a){return a!=NULL ? a->blocksize : 0;}
//Ǥ礭֤
    
static inline int ArUsing(const Array* a){return a!=NULL ? a->use : 0;}
//ѤƤǿ֤

static inline int ArUsingBytes(const Array* a){return a!=NULL ? a->use*a->blocksize : 0;}
//ѤƤХȿ֤

static inline Array* ArSetUsing(Array* a,int u){if(a!=NULL) a->use=u; return a;}
//ѿѹ롣
    
Array* ArDec(Array* ws);
//ѿ򣱸餹0ʲˤϤʤʤ

Array* ArPrint(Array* ws,const char* fmt,...)  __attribute__((format(printf,2,3)));
Array* ArPrintV(Array* ws,const char* fmt,va_list vl);
/* wsprintf롣wsϥꥢ줺wsκǸ˥̥ʸоäɲýϤ롣
   wsΥ֥åϣˤ뤳ȡ
   useϥ̥ޤ᤿ʸˤʤ롣 */

Array* ArSwap(Array* a,Array *b);
// a <--> b

int ArEq(Array* a,Array* b);
// a == b

typedef int (*ArForEachFunc)(void* elem,void* arg);
int ArForEach(Array* ws,ArForEachFunc func,void* arg);
/* func֤齪λ롣λȤֹ֤٤ƤǤȤuse+1ˤʤ롣
   顼(ws==NULL)ΤȤ-1֤*/

typedef int (*ArBufFunc)(void* buf,int bufsize,void* data);
Array* ArBuf(Array* ws,ArBufFunc func,void* data);
/* Хåեɥ쥹Хåե(ñ)桼ǡˤfunc¹Ԥ롣
   funcϽ0֤Хåե­ʤɬפǿ֤
   func0֤ޤaΰ礷ƺfunc¹Ԥ뤳Ȥ򷫤֤
   useꤵʤ */

#ifdef __cplusplus
}
#endif

#define ARELEM(type,ws,n) (type*)ArElem(ws,n)
#define ARVAL(type,ws,n) *ARELEM(type,ws,n)

//(C) 2008 thomas
