// -*- coding:euc-jp -*-
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <stdarg.h>
#include <unistd.h>
#include <signal.h>
#include <setjmp.h>
#include <errno.h>
#include <sys/types.h>
#include <pwd.h>
#include <time.h>
#include "corr.h"
#include "wimeapi.h"
#include "lib/ut.h"
#include "lib/wimeconn.h"
#include "lib/version.h"
#include "lib/log.h"
#include "lib/list.h"
#include <time.h> //timespec
#include <X11/keysym.h>
#include <X11/XKBlib.h>
#include <X11/Xutil.h>

static Array LibCxn;
#define EMPTY_CXN_CELL -1

__attribute__((constructor))
static void wime_api_init(void)
{
    struct sigaction old;
    sigaction(SIGPIPE,NULL,&old);
    if(old.sa_handler==SIG_DFL){
	struct sigaction sa = {.sa_handler=SIG_IGN};
	sigaction(SIGPIPE,&sa,NULL);
    }

    /*
      СϻåȤΥե뤬ĤäƤsocket()ΤFdĤ뤬
      ˽񤭹⤦ȤSIGPIPE롣
    */
}

//LibCxnζν
static void libcxn_ctr(void* adr)
{
    *(int*)adr = EMPTY_CXN_CELL;
}

/*
  socket_num:åȤɲä͡λϥ顼֤롣
  logmark==0ΤȤϺƥȥʥϥɥ餫θƤӽФ
  Ѥ륽å(>=0)֤顼λ-1
*/
int WimeInitialize(int socket_num,int logmark)
{
    //3.3λͽ3.6p4ä2.0äꤷƤ뤬,Ȥꤢ3.6ˤƤ
    //???ĶѿUSERɬȤƤΤ
    if(logmark!=0)
	LogMark=logmark;
    if((SocketPath = MakeSocketPath(socket_num)) == NULL)
	return -1;
    int ret = socket_num;
    if(ConnectServer()){
	int minor,cxn;
	struct passwd* pw = getpwuid(getuid());
	char user[strlen(pw->pw_name)+sizeof(USE_UTF16LE_SYM1)];
	strcat(strcpy(user,pw->pw_name),USE_UTF16LE_SYM1);
	if(Snd0(Fd,"3.6",user) && (cxn = Rcv0(Fd,&minor))!=-1 && minor==WIME_CANNA_MINOR){
	    //LibCxn[0]ϥХ륳ƥ
	    DEBUGLOG(CH_GLOBAL,"recieved cxn %d\n",cxn);
	    *(int*)ArAlloc(ArNewPs(&LibCxn,sizeof(int),libcxn_ctr,16),1) = cxn;
	}else{
	    DisconnectServer();
	    ret = -1;
	    FATALLOG(CH_GLOBAL,"fail connect server\n");
	}
    }else
	ret = -1;

    ShmStartClient(socket_num,true); //СäƤʤƤpidεϿϤƤ
    return ret;
}

static int close_all_context(int* cxp,void* arg UNUSED)
{
    if(*cxp != EMPTY_CXN_CELL)
	CannaCloseContext(*cxp);
    return 0;
}

bool WimeFinalize(void)
{
    bool st = false;
    char code;

    if(Fd != -1){
	//Ƥ륳ƥȤĤ
	ArForEach(&LibCxn,(ArForEachFunc)close_all_context,NULL);

	st = (Snd1(Fd,CANNA_FINALIZE) && Rcv2(Fd,&code) && code==0);
	DisconnectServer();
	ShmEndClient();
    }
    ArDelete(&LibCxn);
    free(SocketPath);
    SocketPath=NULL;
    return st;
}

//connect()ǤɤʤΤǡtrueǤwimeʤǽ⤢
bool WimeIsConnected(void)
{
    return (Fd!=-1);
}

static int count_context(int* cxp,int* counter)
{
    if(*cxp != EMPTY_CXN_CELL)
	++ *counter;
    return 0;
}

//ץ󤵤Ƥ륳ƥȤο
int WimeOpenedContext(void)
{
    int counter=0;
    ArForEach(&LibCxn,(ArForEachFunc)count_context,&counter);
    return counter;
}

//顼λʲ
static int translate_cx(int n)
{
    int* cp = ArElem(&LibCxn,n);
    return cp!=NULL ? *cp : -1;
}
	
//顼λ-1
int CannaCreateContext(void)
{
    int16_t cxn;
    int idx=-1,emp=EMPTY_CXN_CELL;

    if(Snd1(Fd,CANNA_CREATE_CONTEXT) && Rcv5(Fd,&cxn) && cxn!=-1){
	int* adr;
	const int min_context=1; //0ϥХ륳ƥ
	if((idx = ArFind(&LibCxn,min_context,&emp)) == -1){
	    idx = ArUsing(&LibCxn);
	    adr = ArExpand(&LibCxn,1);
	}else
	    adr = ArElem(&LibCxn,idx);
	*adr = cxn;
    }
    return idx;
}

bool CannaCloseContext(int cxn)
{
    char code;
    bool st=false;

    int t_cxn = translate_cx(cxn);
    if(t_cxn>=0 && Snd2(Fd,CANNA_CLOSE_CONTEXT,t_cxn) && Rcv2(Fd,&code) && code==0){
	*(int*)ArElem(&LibCxn,cxn) = EMPTY_CXN_CELL;
	st = true;
    }
    return st;
}

int WimeGetGlobalContext(void)
{
    return 0;
}

bool WimeOpenIMEDialog(int type)
{
    char code=-1;
    return Snd2(Fd,WIME_OpenDialog,(int16_t)type) && Rcv2(Fd,&code) && code!=-1;
}

bool CannaKillServer(void)
{
    char code;
    return Snd1(Fd,CANNA_KILL_SERVER) && Rcv2(Fd,&code) && code==0;
}

/* Ѵλ
   mode		0ʤؽʤߤΤȤѴä
   cl_count	ʸλϸߤθǳꤹ롣
   can_list	ʸΥȸֹΥꥹ(cl_count)
*/
bool CannaEndConvert(int cxn,int mode,int cl_count,const int* can_list)
{
    char code;
    cxn = translate_cx(cxn);

    //intint16Ѵ롣Ϥᤫint16褦ˤ
    int16_t* clist16 = malloc(sizeof(*clist16)*cl_count);
    for(int n=0; n<cl_count; ++n)
	clist16[n] = can_list[n];

    bool st = (cxn>=0 &&
	       Snd10(Fd,CANNA_END_CONVERT,cxn,cl_count,mode,clist16,cl_count) &&
	       Rcv2(Fd,&code) &&
	       code==0);
    free(clist16);
    return st;
}

Array* u16list_to_u8list(uint16_t* u16_raw)
{
    Array lst16;
    ListRaw(ArNew(&lst16,2,NULL),u16_raw);
    char* u8_raw = U16ToU8(NULL,NULL,ArAdr(&lst16),ArUsing(&lst16));
    Array* lst8 = ListRaw(ArNew(NULL,1,NULL),u8_raw);
    free(u8_raw);
    ArDelete(&lst16);
    return lst8;
}

/*
  cxn=ƥֹ
  mode=⡼
  yomi=utf8ɤߡʤҤ餬ʡ
  =ʸκͥΥꥹ(utf8)顼λNULL
*/
Array* CannaBeginConvert(int cxn,int mode,const char* yomi)
{
    int16_t clw;
    uint16_t* lstw=NULL;
    uint16_t* yomiw = U8ToU16(NULL,yomi);
    Array* lst8 = NULL;
    
    cxn = translate_cx(cxn);
    if(cxn>=0 && Snd14(Fd,CANNA_BEGIN_CONVERT,mode,cxn,yomiw) && Rcv7(Fd,&clw,&lstw)){
	lst8 = u16list_to_u8list(lstw);
    }
    free(yomiw);
    free(lstw);
    return lst8;
}

/*
  cxn=ƥֹ
  cl=ʸֹ
  =ʸɤߤΥꥹ(utf8)顼λNULL
 */
Array* CannaGetCandidacyList(int cxn,int cl)
{
    int16_t cnw;
    uint16_t* lstw = NULL;
    Array* lst8 = NULL;

    cxn = translate_cx(cxn);
    if(cxn>=0 && Snd6(Fd,CANNA_GET_CANDIDACY_LIST,cxn,cl,0xffff) && Rcv7(Fd,&cnw,&lstw)){
	lst8 = u16list_to_u8list(lstw);
    }
    free(lstw);
    return lst8;
}

//(utf8)free뤳ȡ
//顼λNULL
char* CannaGetYomi(int cxn,int cl)
{
    int16_t ylen;
    uint16_t* y2=NULL;
    char* y=NULL;
    const int bufsize=1024;

    cxn = translate_cx(cxn);
    bool st= (cxn>=0 && Snd6(Fd,CANNA_GET_YOMI,cxn,cl,bufsize) && Rcv7(Fd,&ylen,&y2));
    if(st){
	y = U16ToU8(NULL,NULL,y2,-1);
    }
    free(y2);
    return y;
}

//ɲðint
bool WimeSetCompWin(int cxn,int style,...)
{
    char code;
    int pn=0;
    uint16_t params[4];
    va_list vl;

    va_start(vl,style);
    switch(style){
    case WIME_POS_DEFAULT:
	pn = 0;
	break;
    case WIME_POS_FORCE:
    case WIME_POS_POINT:
	pn = 2;
	break;
    case WIME_POS_RECT:
	pn = 4;
    }
    for(int n=0; n<pn; ++n)
	params[n] = va_arg(vl,int);
    va_end(vl);
    cxn = translate_cx(cxn);
    return cxn>=0 &&
	Snd11(Fd,WIME_SetCompWin,cxn,style,params,pn) && Rcv2(Fd,&code) &&
	code==1;
}

/*
  xk0=롼1keysym
  xk1=롼2keysymθʤɤ0
  ͡WIME_SENDKEY_XXXX
	ime˽줿Ȥʸ󤬤mallocres֤(utf8)ʤNULL֤롣
*/
int WimeSendKey(int cxn,unsigned xk0,unsigned xk1,unsigned mod,char** res)
{
    int16_t proc;
    cxn = translate_cx(cxn);
    unsigned param[]={cxn,xk0,xk1,mod};
    if(cxn<0 || !SndN(Fd,WIME_SendKey,param,sizeof(param)) || !Rcv6(Fd,&proc,res))
	proc = WIME_SENDKEY_ERROR;
    return proc;
}

/*
  en_ime  0=ime off, 1=ime on, -1=䤤碌
  λtrueСǤȤfalse֤
*/
bool WimeEnableIme(int cxn,int en_ime)
{
    int16_t code;

    cxn = translate_cx(cxn);
    return (cxn>=0 && Snd3(Fd,WIME_EnableIme,cxn,en_ime) && Rcv5(Fd,&code) && code==1);
}

/*
  imcıƥɥΰ֤礭ѹ
  (x,y),(w,h)줾Τɤ餫ǤлѤʤ
*/
bool WimeMoveShadowWin(int cxn,int x,int y,int w,int h)
{
    int16_t ax[]={x,y,w,h};
    char code=false;

    cxn = translate_cx(cxn);
    return 
	cxn>=0 &&
	Snd11(Fd,WIME_MoveShadowWin,cxn,0,(uint16_t*)ax,ITEMS(ax)) &&
	Rcv2(Fd,&code) &&
	code;
}

/*
  ѴɥΥեȤطʿꤹ
  ͡եȤι⤵(ԥ)顼λ0
*/
int WimeSetCompFont(int cxn,const char* font,unsigned bg)
{
    int16_t h;

    cxn = translate_cx(cxn);
    if(cxn<0 || !Snd15(Fd,WIME_SetCompFont,bg,cxn,font) || !Rcv5(Fd,&h))
	h = 0;
    return h;
}

/*
  Ѵʸ(utf8)ȥ롣ɬפʤNULLǤ褤
  ʸmallocǳݤ(ʤNULL֤)
  !!!顼λNULL֤뤬ȥ顼ɤ֤٤
  siФ(ꥢ)롣
 */
char* WimeGetCompStr(int cxn,WimeCompStrInfo* si)
{
    int code=-1;
    char* str=NULL;

    cxn = translate_cx(cxn);
    bool st = (cxn>=0 && Snd2(Fd,WIME_GetCompStr,cxn) && Rcv64(Fd,(unsigned*)&code,(void**)&si,NULL,&str));
    return (st && code>0) ? str : (free(str),NULL);
}

/*
  ImmGetCompositionWindow
  :WIME_POS_xxx
	顼λ0
*/
int WimeGetCompWin(int cxn,int* x,int* y,int* w,int* h)
{
    int v[5],*vp;
    char st=false;

    cxn = translate_cx(cxn);
    if(cxn>=0 && Snd2(Fd,WIME_GetCompWin,cxn) && Rcv4(Fd,&st,vp=v) && st){
	++vp; //style
	*x = *(vp++);
	*y = *(vp++);
	*w = *(vp++);
	*h = *vp;
    }else
	v[0] = 0;
    return v[0];
}

/*
  style=WIME_POS_...
  WIME_POS_POINTΤȤɲðint x,y
  WIME_POS_EXCLUDEΤȤϤint x,y,w,h(l,t,r,bǤϤʤ)
*/
bool WimeSetCandWin(int cxn,int style,...)
{
    char code=false;
    int len=2;
    
    cxn = translate_cx(cxn);
    int32_t ax[8]={cxn,style};
    DEBUGLOG(CH_GLOBAL,"cxn %d style 0x%x\n",ax[0],ax[1]);
    if(style != WIME_POS_DEFAULT){
	va_list vl;
	va_start(vl,style);
	for(int n=0; n<2; ++n,++len)
	    ax[len] = va_arg(vl,int);
	if(style == WIME_POS_EXCLUDE){
	    for(int n=0; n<4; ++n,++len)
		ax[len] = va_arg(vl,int);
	}
	va_end(vl);
    }
    return
	cxn>=0 &&
	SndN(Fd,WIME_SetCandWin,ax,len*sizeof(ax[0])) &&
	Rcv2(Fd,&code) &&
	code;
}

/*
  cxnбXΥɥϿ롣
*/
bool WimeRegXWindow(int cxn,unsigned w)
{
    cxn = translate_cx(cxn);
    PktRegXWin p = {cxn,w};
    return cxn>=0 && SndN(Fd,WIME_RegXWin,&p,sizeof(p));
}

/*
  ʸutf8֤
  ͤfree뤳ȡ
  !!!顼λNULL֤뤬ȥ顼ɤ֤٤
*/
char* WimeGetResultStr(int cxn)
{
    CanHeader* q = NULL;
    char* u8 = NULL;
    
    cxn = translate_cx(cxn);
    if(cxn>=0 && Snd2(Fd,WIME_GetResultStr,(int16_t)cxn) && (q=RcvN(Fd,NULL,0))!=NULL){
	if(q->Length != 0)
	    u8 = U16ToU8(NULL,NULL,(uint16_t*)(q+1),-1);
    }
    free(q);
    return u8;
}

/*
  u8ѴλʸȤcxn롣
  cxnλϤͤwime serverǤΥƥidȤƤΤޤ޻Ȥ
*/
bool WimeSetResultStr(int cxn,const char* u8)
{
    bool st=false;
    cxn = cxn>0 ? translate_cx(cxn) : -cxn;
    uint16_t* u16 = U8ToU16(NULL,u8);
    if(cxn>=0 && Snd11(Fd,WIME_SetResultStr,cxn,0,u16,-1))
	st = true;
    free(u16);
    return st;
}

/*
  Ѵ롣
  u8=Ѵʸ(utf8)
  cursor=(ʸñ)
  ͡оʬĹʸñ̡ˡ顼λ
	pos=оʬγϰ֡ʸñ̡ˡ
*/
int WimeReconvert(int cxn,const char* u8,int cursor,int* pos)
{
    char code;
    int32_t info[2];
    
    cxn = translate_cx(cxn);
    uint16_t* u16 = U8ToU16(NULL,u8);
    if(cxn<0 || !Snd11(Fd,WIME_Reconvert,cxn,cursor,u16,-1) || !Rcv4(Fd,&code,info) || !code){
	info[1] = 0;
    }
    free(u16);
    *pos = info[0];
    return info[1];
}

/*
  եΰưΤ餻
*/
bool WimeSetFocus(int cxn,bool in)
{
    cxn = translate_cx(cxn);
    int32_t p[] = {cxn,in};
    return cxn>=0 && SndN(Fd,WIME_SetImeFocus,p,sizeof(p));
}

/*
  imeΥġСɽ
  tb		ġСɽ
  comp_win	ѴɥȤ
*/
bool WimeShowToolbar(int cxn,bool tb,bool comp_win)
{
    cxn = translate_cx(cxn);
    return cxn>=0 && Snd7(Fd,WIME_ShowToolbar,cxn,tb,comp_win);
}

#define ALGN(n) ((n/sizeof(int)+1)*sizeof(int))

/*
  ñϿ˻Ȥʻΰ(utf8)
   ʻ̾Υꥹ(utf8) 顼äȤNULL
	items:ǿ
	code:ɤfree뤳
*/
Array* WimeGetStyleList(int* items,int** code)
{
    *code = NULL;
    Array* desclist=NULL;
    char* desc;
    if(Snd1(Fd,WIME_GetStyleList) && Rcv64(Fd,(unsigned*)items,(void**)code,NULL,&desc)){
	desclist = ListRaw(ArNew(NULL,1,NULL),desc);
	free(desc);
    }
    return desclist;
}

/*
  եɤ߹ߤ
*/
bool WimeReset(void)
{
    void* r;
    char buf[sizeof(CanHeader)+sizeof(int)];
    CanHeader* ch = (CanHeader*)buf;

    return
	Snd1(Fd,WIME_ReloadConf) &&
	(r=RcvN(Fd,ch,sizeof(buf)))!=NULL &&
	r==ch &&
	*(int*)(ch+1)==0;
}

/*
  wime¦Υå롼פ󤹡
  !!! WimeResetƱɡ
*/
bool WimeFlushMsg(void)
{
    void* r;
    char buf[sizeof(CanHeader)+sizeof(int)];
    CanHeader* ch = (CanHeader*)buf;

    return
	Snd1(Fd,WIME_FlushMsg) &&
	(r=RcvN(Fd,ch,sizeof(buf)))!=NULL &&
	r==ch &&
	*(int*)(ch+1)==0;
}

/*
  Ѵ䥦ɥɽ/ɽ
*/
bool WimeShowCandWin(int cxn,bool en)
{
    char code=false;

    cxn = translate_cx(cxn);
    return
	cxn>=0 &&
	Snd3(Fd,WIME_ShowCandWin,cxn,en) &&
	Rcv2(Fd,&code) &&
	code;
}

/*
  Ѵ򤹤
  !!!WimeShowCandidateWindowƱ
*/
bool WimeSelectCand(int cxn,unsigned index)
{
    char code=false;

    cxn = translate_cx(cxn);
    return
	cxn>=0 &&
	Snd3(Fd,WIME_SelectCand,cxn,index) &&
	Rcv2(Fd,&code) &&
	code;
}

/*
  Ѵ䥦ɥĤ롣
*/
bool WimeCloseCandWin(int cxn)
{
    cxn = translate_cx(cxn);
    return cxn>=0 && Snd2(Fd,WIME_CloseCandWin,cxn);
}

/*
  ǥХå
  cxnλѴ˻Ѥ롣
  num={contex,flags}ο顼λ-1
  ͤfree뤳ȡ
*/
uint32_t* WimeDumpContext(bool do_set,int cxn,int flags,int* num)
{
    *num = -1;
    if(cxn >= 0){
	if((cxn = translate_cx(cxn)) < 0){
	    return NULL; //ƥְֹ㤤
	}
    }else
	cxn = -cxn;
    int16_t p1;
    uint32_t* p2;
    return Snd6(Fd,WIME_DumpContext,do_set,cxn,flags) && Rcv9v(Fd,&p1,&p2)>=0 ?
	(*num=p1,p2) : NULL;
}

/*
  verbose٥channelꤷľ
*/
bool WimeSetDebugChannel(int level,int ch)
{
    return Snd5(Fd,WIME_SetDebugChannel,level,0,ch);
}

#include <X11/Xlib.h>
#include "xres.h"

//ΣĤɬꤹ뤳
void (*WimePreedit)(const char* u8,const WimeCompStrInfo* si,void* arg);
void (*WimeConvert)(const char* u8,const WimeCompStrInfo* si,void* arg);
void (*WimeCommit)(const char* u8,const char* composition,const WimeCompStrInfo* si,void* arg);

static char* wime_get_sur(int* cursor_pos,void* arg){return NULL;}
static bool wime_conv_start(int cxn,bool st,void* arg){
    return WimeEnableIme(cxn,(int)st);
}
static bool wime_cand(const char* u8,const WimeCompStrInfo* si,void* arg){return false;}
//ʲϤʤƤ⤤
char* (*WimeGetSurrounding)(int* cursor_pos,void* arg) = wime_get_sur; //ʸmalloc֤
void (*WimeDelSurrounding)(int pos,int len,void* arg); //WimeGetSurroundingȤȤ
bool (*WimeConvStart)(int cxn,bool st,void* arg) = wime_conv_start;
//Preedit,Convert˸ƤӽФ롣true֤u8siľ
bool (*WimeOpenCandidate)(const char* u8,const WimeCompStrInfo* si,void* arg) = wime_cand;
bool (*WimeChangeCandidate)(const char* u8,const WimeCompStrInfo* si,void* arg) = wime_cand;

static char* get_comp_str(int cxn,WimeCompStrInfo* si,int keysym,int state)
{
    char* str = WimeGetCompStr(cxn,si);
    si->Keysym = keysym;
    si->Modifiers = state;
    return str;
}

/*
		str	si
  ʤ	NULL	CursorPos=-1
  ȥ	NULL	CursorPos=0
  	ʸ	TargetClause=-1,CursorPos>=0
  Ѵ	ʸ	TargetClause>=0
  		ʸ	TargetClause=-1,CursorPos=-1
  ʸutf8

  ʸtrue֤
*/
bool WimeFilterKey(int cxn,const ToggleKey* tk,Display* disp,int keycode,int keysym0,int state,void* arg)
{
    DEBUGLOG(CH_GLOBAL,"keycode 0x%x, keysym 0x%x, state 0x%x\n",keycode,keysym0,state);

    //եȰʳνñΥ٥Ȥ̵뤹롣
    if(keysym0!=XK_Shift_L && keysym0!=XK_Shift_R && IsModifierKey(keysym0)){
	DEBUGLOG(CH_GLOBAL,"single modifier\n");
	return true;
    }
    
    if((state & 0xff) == AUX_INPUT_MOD){ //[atok]ѥåȤ
	char* u8 = WimeGetResultStr(cxn);
	DEBUGLOG(CH_GLOBAL,"aux input,utf8 string=[%*D]\n",strlen(u8),u8);
	(*WimeCommit)(u8,NULL,NULL,arg);
	free(u8);
	return true;
    }

    int shiftlevel = (state & ShiftMask) ? 1 : 0;
    if((state & MODESWITCHMASK) != 0){
	keysym0 = XkbKeycodeToKeysym(disp,keycode,1,shiftlevel);
	DEBUGLOG(CH_GLOBAL,"mode switch --> 0x%x\n",keysym0);
    }

    ImeStateKeyType togglekey = IsToggleKey(tk,keysym0,state);
    if(togglekey != IMESTATUS_NO_TOGGLE){
	bool mode=0;
	switch(togglekey){
	case IMESTATUS_ON:
	    mode = true;
	    break;
	case IMESTATUS_OFF:
	    mode = false;
	    break;
	case IMESTATUS_TOGGLE:
	    mode = !WimeEnableIme(cxn,IME_QUERY);
	case IMESTATUS_NO_TOGGLE:;
	}
	bool st=true;
	if(mode){
	    //⡼ɳ
	    DEBUGLOG(CH_GLOBAL,"cxn %d:enable ime\n",cxn);
	    st = (*WimeConvStart)(cxn,IME_ON,arg);
	}else{
	    //⡼ɽλ
	    char* str = WimeGetCompStr(cxn,NULL);
	    if(str == NULL){
		DEBUGLOG(CH_GLOBAL,"cxn %d:disable ime\n",cxn);
		st = (*WimeConvStart)(cxn,IME_OFF,arg);
	    }
	    /*
	      Ѵʸ󤬤д⡼ɤ³
	    */
	    free(str); //Ѵʸ˴롣
	}
	return st;
    }

    //tk==NULLΤȤϥ⡼ɤ˴ؤ餺WimeSendKeyعԤ
    if(tk!=NULL && !WimeEnableIme(cxn,IME_QUERY)){
	return false; //ľ
    }

    //Ѵ
    if(keysym0 == XK_Mode_switch) //modeswitchñΤϽʤ
	return false;
    char* str;
    KeySym keysym1 = XkbKeycodeToKeysym(disp,keycode,1,shiftlevel);//롼ףkeysym
    int send_st = WimeSendKey(cxn,keysym0,keysym1,state,&str);
    if(send_st <= 0)
	return false;//ʤäor顼

    if(send_st == WIME_SENDKEY_RECONV){ //Ѵä
	bool st = false;
	int cursor;
	char* u8 = (*WimeGetSurrounding)(&cursor,arg);
	if(u8 != NULL){
	    int pos,len;
	    DEBUGLOG(CH_GLOBAL,"cursor %d '%U'\n",cursor,u8);
	    if((len = WimeReconvert(cxn,u8,cursor,&pos))!=0){
		pos -= cursor; //ʸäʥ뤫а֡
		DEBUGLOG(CH_GLOBAL,"delete pos %d,len %d\n",pos,len);
		(*WimeDelSurrounding)(pos,len,arg);
		WimeCompStrInfo si;
		str = get_comp_str(cxn,&si,keysym0,state);
		(*WimeConvert)(str,&si,arg);
		st = true;
	    }
	    free(u8);
	}
	return st;
    }

    //줿
    WimeCompStrInfo si;
    if(str == NULL){
	str = get_comp_str(cxn,&si,keysym0,state);

	if(send_st==WIME_SENDKEY_OPENCAND && (*WimeOpenCandidate)(str,&si,arg)){
	    free(str);
	    str = get_comp_str(cxn,&si,keysym0,state);
	}
	if(send_st==WIME_SENDKEY_CHGCAND && (*WimeChangeCandidate)(str,&si,arg)){
	    free(str);
	    str = get_comp_str(cxn,&si,keysym0,state);
	}

	if(str != NULL){
	    if(si.TargetClause == -1)
		(*WimePreedit)(str,&si,arg);	//
	    else
		(*WimeConvert)(str,&si,arg);	//Ѵ
	}else{
	    (*WimePreedit)("",&si,arg); //bsʤɤѴʸ󤬤ʤʤäescǥ󥻥뤷
	}
    }else{
	char* rest = get_comp_str(cxn,&si,keysym0,state);
	(*WimeCommit)(str,rest,&si,arg);			//
	free(rest);
    }
    
    free(str);
    return true;
}



int RestartServerCount;
static WimeRestartFunc RestartFunc;
static void restart_server(int signum UNUSED)
{
    PidTableElt elt = {0};
    ShmGetPidData(getpid(),&elt);

    DisconnectServer(); //fdľfdĤ롣
    //SemWait(NULL,elt.SocketNum);
    //SemUnlink(elt.SocketNum);
    WimeInitialize(elt.SocketNum,0);
    ++RestartServerCount;
    INFOLOG(CH_GLOBAL,"pid %d,catch server restart signal\n",(int)getpid());
    if(RestartFunc!=NULL)
	(*RestartFunc)();
}

/*
  СƵưȤ³˸ƤФؿϿ롣ɬפʤNULLꤹ롣
*/
void WimeRestartSignal(WimeRestartFunc handler)
{
    struct sigaction act = {.sa_handler = restart_server};
    if(sigaction(WIMERESTARTSIG,&act,NULL)!=0){
	ERR("fail sigaction:(%d) %m\n",errno);
    }
    RestartFunc = handler;
}

static Array MsgBuf;

__attribute__((constructor))
static void wime_log_init(void)
{
    ArNew(&MsgBuf,1,NULL);
}

//wime˽ϤǤȤtrue
static bool log_v(char mark,const char* fmt,va_list vl)
{
    char code;
    bool st=false;

    ArPrintV(ArClear(&MsgBuf),fmt,vl);
    if(WimeIsConnected()){
	//wime.clog_req()ǽƤ
	st=(Snd15(Fd,WIME_Log,mark,0,ArAdr(&MsgBuf)) && Rcv2(Fd,&code) && code);
    }else{
	struct timespec t;
	clock_gettime(CLOCK_MONOTONIC,&t); 
	printf("[%c][%lu.%lu]%s",mark,t.tv_sec,t.tv_nsec/1000,(const char*)ArAdr(&MsgBuf));
	fflush(stdout);
	st=true;
    }
    return st;
}

bool Msg(char mark,const char* fmt,...)
{
    va_list vl;
    bool st;

    va_start(vl,fmt);
    st=log_v(mark,fmt,vl);
    va_end(vl);
    return st;
}

#if 1
/*
  data,size˥إåϴޤबѤʤsizeϤǥإåʬ򸺻롣
  ֤줿ǡϥإåޤࡣfree()뤳ȡ
  ϤȤǡ򤽤ΤޤϤΤǡѥ᡼ΥХȥդ뤳ȡ
 */
void* WimeRawData(int major,int minor,const void* data,int size)
{
    return SndN(Fd,(minor<<8)|major,((CanHeader*)data)+1,size-sizeof(CanHeader)) ? RcvN(Fd,NULL,0) : NULL;
}
#endif

/*
  Խʸɽ롣
  tbl礭ϺATIMECOMPCOL_ITEMMAXĤʤФʤʤ
  ̿˼ԤȤfalse֤atokʤȤϥǥեȤο֤
 */
bool WimeGetColor(int cxn,ATImeCol* tbl)
{
    char* col=NULL;
    int16_t rcv_st;
    cxn = translate_cx(cxn);
    bool st =  cxn>=0 && Snd2(Fd,WIME_GetColor,cxn) && Rcv6(Fd,&rcv_st,&col);
    if(st){
	memcpy(tbl,col,sizeof(ATImeCol)*ATIMECOMPCOL_ITEMMAX);
	free(col);
    }
    return st;
}

bool WimeGetCandWin(int cxn,int* data)
{
    cxn = translate_cx(cxn);
    int16_t api_st;
    uint32_t* dp = NULL;
    int dpcount = 0;
    bool st =  cxn>=0 && Snd2(Fd,WIME_GetCandWin,cxn) && (dpcount=Rcv9v(Fd,&api_st,&dp))>0;
    if(st && api_st){
	while(--dpcount >= 0)
	    data[dpcount] = (int32_t)dp[dpcount];
    }else
	st = false;
    free(dp);
    return st;
}

char* CannaStoreRange(int cxn,int clindex,const char* yomi)
{
    uint16_t* yomiw = U8ToU16(NULL,yomi);
    uint16_t* candw;
    char* cand = NULL;
    int16_t st;
    
    cxn = translate_cx(cxn);
    if(cxn>=0 && Snd11(Fd,CANNA_STORE_RANGE,cxn,clindex,yomiw,-1) && Rcv7(Fd,&st,&candw) && st!=-1){
	cand = U16ToU8(NULL,NULL,candw,-1);
    }
    free(yomiw);
    return cand;
}

int WimeCandIndex(int cxn)
{
    cxn = translate_cx(cxn);
    int16_t index;
    if(cxn<0 || !Snd2(Fd,WIME_CandIndex,cxn) || !Rcv5(Fd,&index))
	index = -1;
    return index;
}

//(C) 2008 thomas
